# -*- python -*-
# $RCSfile: materialparameter.py,v $
# $Revision: 1.1 $
# $Author: redwing $
# $Date: 2005/01/26 20:04:12 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov.

# Menu for operations related to the MaterialsManager.  Provides
# for the selection and deselection of materials and properties,
# creation and deletion of new materials, and the population of
# materials with properties.  Parametrization of properties themselves
# is handled by the corresponding propertymenu, and saving and loading
# are handled by the "File" submenu of the main OOF menu. 

# These menu operations need not correspond to entries
# in a menu bar -- they're triggered from the GUI by operations
# on the non-menubar buttons of the MaterialsPane.

from common import debug
from common.IO import parameter
from engine import materialmanager



###################

class MaterialParameter(parameter.StringParameter):
    def checker(self, x):
        if x not in materialmanager.getMaterialNames():
            raise TypeError("Expected a Material name!")

class ListOfMaterialsParameter(parameter.ListOfStringsParameter):
    def checker(self, x):
        if type(x) is not types.ListType:
            raise TypeError("Expected a list of Material names!")
        names = materialmanager.getMaterialNames()
        for n in x:
            if n not in names:
                raise TypeError("Expected a list of Material names!")


