# This file was created automatically by SWIG.
import propertyoutputc
class PropertyOutputInitPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C PropertyOutputInit instance at %s>" % (self.this,)
class PropertyOutputInit(PropertyOutputInitPtr):
    def __init__(self,this):
        self.this = this




class ScalarPropertyOutputInitPtr(PropertyOutputInitPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C ScalarPropertyOutputInit instance at %s>" % (self.this,)
class ScalarPropertyOutputInit(ScalarPropertyOutputInitPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(propertyoutputc.new_ScalarPropertyOutputInit,_args,_kwargs)
        self.thisown = 1




class TwoVectorPropertyOutputInitPtr(PropertyOutputInitPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C TwoVectorPropertyOutputInit instance at %s>" % (self.this,)
class TwoVectorPropertyOutputInit(TwoVectorPropertyOutputInitPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(propertyoutputc.new_TwoVectorPropertyOutputInit,_args,_kwargs)
        self.thisown = 1




class ThreeVectorPropertyOutputInitPtr(PropertyOutputInitPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C ThreeVectorPropertyOutputInit instance at %s>" % (self.this,)
class ThreeVectorPropertyOutputInit(ThreeVectorPropertyOutputInitPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(propertyoutputc.new_ThreeVectorPropertyOutputInit,_args,_kwargs)
        self.thisown = 1




class SymmMatrix3PropertyOutputInitPtr(PropertyOutputInitPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C SymmMatrix3PropertyOutputInit instance at %s>" % (self.this,)
class SymmMatrix3PropertyOutputInit(SymmMatrix3PropertyOutputInitPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(propertyoutputc.new_SymmMatrix3PropertyOutputInit,_args,_kwargs)
        self.thisown = 1




class PropertyOutputPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def name(self, *_args, **_kwargs):
        val = apply(propertyoutputc.PropertyOutput_name,(self,) + _args, _kwargs)
        return val
    def evaluate(self, *_args, **_kwargs):
        val = apply(propertyoutputc.PropertyOutput_evaluate,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C PropertyOutput instance at %s>" % (self.this,)
class PropertyOutput(PropertyOutputPtr):
    def __init__(self,this):
        self.this = this




class PropertyOutputRegistrationPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def name(self, *_args, **_kwargs):
        val = apply(propertyoutputc.PropertyOutputRegistration_name,(self,) + _args, _kwargs)
        return val
    def initializer(self, *_args, **_kwargs):
        val = apply(propertyoutputc.PropertyOutputRegistration_initializer,(self,) + _args, _kwargs)
        if val: val = PropertyOutputInitPtr(val) 
        return val
    def instantiate(self, *_args, **_kwargs):
        val = apply(propertyoutputc.PropertyOutputRegistration_instantiate,(self,) + _args, _kwargs)
        if val: val = PropertyOutputPtr(val) ; val.thisown = 1
        return val
    def __repr__(self):
        return "<C PropertyOutputRegistration instance at %s>" % (self.this,)
class PropertyOutputRegistration(PropertyOutputRegistrationPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(propertyoutputc.new_PropertyOutputRegistration,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: propertyoutput_.py,v $
# $Revision: 1.12 $
# $Author: redwing $
# $Date: 2005/03/03 18:26:35 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov.

from SWIG.engine import outputval
from SWIG.engine import symmmatrix
from common import debug
from common.IO import output
from engine.IO import outputClones
import types

# The PropertyOutputRegistration subclasses create an Output object
# for each registered PropertyOutput.  This bridges the gap between
# the C++ PropertyOutputs and the more general Python Outputs.


##### Scalar outputs

class ScalarPropertyOutputRegistration(PropertyOutputRegistration):
    def __init__(self, name, initializer=None, parameters=[],
                 tip=None, discussion=None):
        PropertyOutputRegistration.__init__(
            self, name, initializer or ScalarPropertyOutputInit())
        op = output.Output(name=name, func=self.opfunc,
                           oType=types.FloatType,
                           parameters=parameters,
                           tip=tip, discussion=discussion)
        output.defineScalarOutput(name, op)
        output.defineAggregateOutput(name, op)

    def opfunc(self, mesh, elements, coords, parameters, *args, **kwargs):
        # Returns a list of Floats.
        ans = []
        po = self.instantiate([p.value for p in parameters])
        initializer = self.initializer()
        for element, ecoords in zip(elements, coords):
            ans += po.evaluate(mesh, element, initializer, ecoords)
        return [a.value() for a in ans] # convert from ScalarOutputVal to Float
    
##### SymmMatrix3 outputs.

class SymmMatrix3PropertyOutputRegistration(PropertyOutputRegistration):
    def __init__(self, name, initializer=None, parameters=[],
                 tip=None, discussion=None):
        PropertyOutputRegistration.__init__(
            self, name, initializer or SymmMatrix3PropertyOutputInit())
        op = output.Output(name=name, func=self.opfunc,
                           oType=outputval.OutputValPtr,
                           parameters=parameters,
                           tip=tip,
                           discussion=discussion)
        output.defineAggregateOutput(name, op)

        compout = outputClones.ComponentOutput.clone(
            name=name+" Component",
            inputs=output.Input("field", outputval.OutputValPtr,
                                op.clone()),
            tip='Compute components of %s' % name,
            discussion=
            """
            <para>Compute the specified component of <link
            linkend='Output:%s'>%s</link> on a &mesh;.</para>
            """
            % (name, name))
        output.defineScalarOutput(name+":Component", compout)
        
        invout = outputClones.InvariantOutput.clone(
            name=name+" Invariant",
            inputs=output.Input("field", outputval.OutputValPtr,
                                op.clone()),
            tip='Compute invariants of %s' % name,
            discussion="""
            <para>Compute the specified invariant of <link
            linkend='Output:%s'>%s</link> on a &mesh;.</para>
            """
            % (name, name))
        output.defineScalarOutput(name+":Invariant", invout)
        output.defineAggregateOutput(name+":Invariant", invout)

    def opfunc(self, mesh, elements, coords, parameters, *args, **kwargs):
        # Returns a list of OutputVal instances.
        ans = []
        po = self.instantiate([p.value for p in parameters])
        initializer = self.initializer()
        for element, ecoords in zip(elements, coords):
            ans += po.evaluate(mesh, element, initializer, ecoords)
        return ans


## ThreeVector outputs
class ThreeVectorPropertyOutputRegistration(PropertyOutputRegistration):
    def __init__(self, name, initializer=None, parameters=[],
                 tip=None, discussion=None):
        PropertyOutputRegistration.__init__(
            self, name, initializer or ThreeVectorPropertyOutputInit())
        op = output.Output(name=name, func=self.opfunc,
                           oType=outputval.OutputValPtr,
                           parameters=parameters,
                           tip=tip,
                           discussion=discussion)
        output.defineAggregateOutput(name, op)

        compout = outputClones.ComponentOutput.clone(
            name=name+" Component",
            inputs=output.Input("field", outputval.OutputValPtr,
                                op.clone()),
            tip='Compute components of %s' % name,
            discussion=
            """
            <para>Compute the specified component of <link
            linkend='Output:%s'>%s</link> on a &mesh;.</para>
            """
            % (name, name))
        output.defineScalarOutput(name+":Component", compout)
        
    def opfunc(self, mesh, elements, coords, parameters, *args, **kwargs):
        # Returns a list of OutputVal instances.
        ans = []
        po = self.instantiate([p.value for p in parameters])
        initializer = self.initializer()
        for element, ecoords in zip(elements, coords):
            ans += po.evaluate(mesh, element, initializer, ecoords)
        return ans
