# This file was created automatically by SWIG.
import nonlinearc
from SWIG.engine.properties import PropertyPtr
from SWIG.engine.property.elasticity.cijkl import CijklPtr
from SWIG.engine.property.elasticity.elasticity import ElasticityPtr
class NonLinearElasticityPropPtr(ElasticityPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def cijkl_pointer(self, *_args, **_kwargs):
        val = apply(nonlinearc.NonLinearElasticityProp_cijkl_pointer,(self,) + _args, _kwargs)
        if val: val = CijklPtr(val) 
        return val
    def __repr__(self):
        return "<C NonLinearElasticityProp instance at %s>" % (self.this,)
class NonLinearElasticityProp(NonLinearElasticityPropPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(nonlinearc.new_NonLinearElasticityProp,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: nonlinear_.py,v $
# $Revision: 1.9 $
# $Author: haan $
# $Date: 2004/11/10 15:39:15 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov.

from common.IO import parameter
from SWIG.common import devel
from engine import problem
from engine import propertyregistration
from engine.IO import isocijkl
import types

PropertyRegistration = propertyregistration.PropertyRegistration
FloatParameter = parameter.FloatParameter


if devel.devel():
    PropertyRegistration(
        'Elasticity:NonLinearElasticity', NonLinearElasticityProp,
        "SWIG.engine.property.elasticity.nonlinear.nonlinear",200,
        [isocijkl.IsotropicRank4TensorParameter('cijkl',
                     isocijkl.IsotropicRank4TensorEnu(young=1.0, poisson=0.2),
                                                tip=parameter.emptyTipString),
         FloatParameter('hardening', 0.0, tip = 'Reversible rate of change of the elastic constant upon applied strain.')],
        fields=[problem.Displacement],
        fluxes=[problem.Stress],
        outputs=["Energy"],
        propertyType="Elasticity",
        nonlinear=1)


# Repr refers to registration name, not actual class name.
def _NonLinearElasticity___repr__(self):
    return "NonLinearElasticity(name='%s', cjikl=%s, hardening=%s)" % \
           (self.name(), `self.cijkl_param()`,
            `self.kappa()`)

NonLinearElasticityPropPtr.__repr__ = _NonLinearElasticity___repr__

# Ought to be possible to use the instance's conversion machine?
# Or some other more general interface.
def _NonLinearElasticity_cijkl_param(self):
    cijkl = self.cijkl_pointer()
    
    return isocijkl.IsotropicRank4TensorCij(c11 = cijkl[0,0], c12=cijkl[0,1])

NonLinearElasticityPropPtr.cijkl_param = _NonLinearElasticity_cijkl_param
