// -*- C++ -*-
// $RCSfile: massdensity.h,v $
// $Revision: 1.9 $
// $Author: redwing $
// $Date: 2004/12/17 18:03:50 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#ifndef MASSDENSITY_H
#define MASSDENSITY_H

#include "engine/property.h"
#include <string>

class Cijkl;
class Element;
class Flux;
class Material;
class FEMesh;
class Position;
class TwoVectorField;
class SymmetricTensorFlux;
class ElementNodeIterator;

class MassDensityProp : public Property {
private:
  double density;
public:
  MassDensityProp(PyObject *reg, const std::string &name, double rho);
  virtual ~MassDensityProp() {}
  virtual void precompute();
  virtual void fluxrhs(const FEMesh*, const Element*, const Flux*, FluxData*,
		       const MasterPosition&) const;
  virtual int K_integration_order(int) const;
  double densityvalue() const { return density; }
  virtual int is_symmetric(const FEMesh*) const {return 1;}
protected:
  TwoVectorField *displacement;
  SymmetricTensorFlux *stress_flux;
};

#endif
