# This file was created automatically by SWIG.
import thermalexpansionc
from SWIG.engine.properties import PropertyPtr
from SWIG.engine.symmmatrix import SymmMatrix3Ptr
class IsotropicThermalExpansionPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def alpha(self, *_args, **_kwargs):
        val = apply(thermalexpansionc.IsotropicThermalExpansion_alpha,(self,) + _args, _kwargs)
        return val
    def tzero(self, *_args, **_kwargs):
        val = apply(thermalexpansionc.IsotropicThermalExpansion_tzero,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C IsotropicThermalExpansion instance at %s>" % (self.this,)
class IsotropicThermalExpansion(IsotropicThermalExpansionPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(thermalexpansionc.new_IsotropicThermalExpansion,_args,_kwargs)
        self.thisown = 1




class AnisotropicThermalExpansionPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def alpha(self, *_args, **_kwargs):
        val = apply(thermalexpansionc.AnisotropicThermalExpansion_alpha,(self,) + _args, _kwargs)
        if val: val = SymmMatrix3Ptr(val) 
        return val
    def tzero(self, *_args, **_kwargs):
        val = apply(thermalexpansionc.AnisotropicThermalExpansion_tzero,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C AnisotropicThermalExpansion instance at %s>" % (self.this,)
class AnisotropicThermalExpansion(AnisotropicThermalExpansionPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(thermalexpansionc.new_AnisotropicThermalExpansion,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: thermalexpansion_.py,v $
# $Revision: 1.29 $
# $Author: redwing $
# $Date: 2005/02/02 21:45:23 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 


from SWIG.engine import symmmatrix
from common import utils
from common.IO import parameter
from engine import problem
from engine import propertyregistration

PropertyRegistration = propertyregistration.PropertyRegistration

class TriclinicThermalExpansion(AnisotropicThermalExpansion):
    def __init__(self, registration, name, alpha, T0):
        self.T0 = T0
        AnisotropicThermalExpansion.__init__(self, registration, self, name,
                                 alpha, T0)
    def __repr__(self):
        return "Triclinic(name='%s', alpha=%s, T0 =%g)" % \
               (self.name(),`self.alpha()`, self.T0)


PropertyRegistration(
    'Thermal:ThermalExpansion:Anisotropic:Triclinic',
    TriclinicThermalExpansion,
    "SWIG.engine.property.thermalexpansion.thermalexpansion",210,
    [symmmatrix.TriclinicRank2TensorParameter('alpha',
                                     symmmatrix.TriclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
                                     tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature. Sometimes referred to as the deposition temperature.")],
    fields=[problem.Temperature],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="ThermalExpansion",
    tip='Triclinic thermal expansion')

### Property reprs refer to the registered name, not the actual class name.
##def _ThermalExpansion___repr__(self):
##    return "ThermalExpansion(name='%s', alpha=%s, t0=%s)" % \
##           (self.name(), `self.alpha()`, `self.tzero()`)

##ThermalExpansionPtr.__repr__ = _ThermalExpansion___repr__


##class IsoThermalExpansion(IsotropicThermalExpansion):
##    def __init__(self, registration, name, alpha, T0):
##        self.alpha = alpha
##        self.T0 = T0
##        ## alphaij = symmmatrix.SymmMatrix3(alpha, alpha, alpha, 0., 0., 0.)
##        IsotropicThermalExpansion.__init__(self, registration, name,
##                                 alpha, T0)

def __IsotropicThermalExpansion__repr__(self):
        return "Isotropic(name='%s', alpha=%s, T0=%g)" % \
               (self.name(),`self.alpha()`, self.tzero())

PropertyRegistration(
    'Thermal:ThermalExpansion:Isotropic', IsotropicThermalExpansion,
    "SWIG.engine.property.thermalexpansion.thermalexpansion",200,
    [parameter.FloatParameter('alpha', 1.0,
                                     tip="Thermal expansion coefficient."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature.")],
    fields=[problem.Temperature],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="ThermalExpansion",
    tip='Isotropic thermal expansion')

IsotropicThermalExpansionPtr.__repr__ = __IsotropicThermalExpansion__repr__


class MonoclinicThermalExpansion(AnisotropicThermalExpansion):
    def __init__(self, registration, name, alpha, T0):
        self.T0 = T0
        AnisotropicThermalExpansion.__init__(self, registration, self, name,
                                 alpha, T0)
    def __repr__(self):
        return "Monoclinic(name='%s', alpha=%s, T0 =%g)" % \
               (self.name(),`self.alpha()`, self.T0)


PropertyRegistration(
    'Thermal:ThermalExpansion:Anisotropic:Monoclinic', MonoclinicThermalExpansion,
    "SWIG.engine.property.thermalexpansion.thermalexpansion",209,
    [symmmatrix.MonoclinicRank2TensorParameter(
    'alpha',
    symmmatrix.MonoclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0), tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature.")],
    fields=[problem.Temperature],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="ThermalExpansion",
    tip='Monoclinic thermal expansion.')

class OrthorhombicThermalExpansion(AnisotropicThermalExpansion):
    def __init__(self, registration, name, alpha, T0):
        self.T0 = T0
        AnisotropicThermalExpansion.__init__(self, registration, self, name,
                                             alpha, T0)
    def __repr__(self):
        return "Orthorhombic(name='%s', alpha=%s, T0 =%g)" % \
               (self.name(),`self.alpha()`, self.T0)


PropertyRegistration(
    'Thermal:ThermalExpansion:Anisotropic:Orthorhombic', OrthorhombicThermalExpansion,
    "SWIG.engine.property.thermalexpansion.thermalexpansion",208,
    [symmmatrix.OrthorhombicRank2TensorParameter(
    'alpha',
    symmmatrix.OrthorhombicRank2Tensor(xx=1.0, yy=1.0, zz=1.0), tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature.")],
    fields=[problem.Temperature],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="ThermalExpansion",
    tip='Orthorhombic thermal expansion.')


class TetragonalThermalExpansion(AnisotropicThermalExpansion):
    def __init__(self, registration, name, alpha, T0):
        self.T0 = T0
        AnisotropicThermalExpansion.__init__(self, registration, self, name,
                                             alpha, T0)
    def __repr__(self):
        return "Tetragonal(name='%s', alpha=%s, T0 =%g)" % \
               (self.name(),`self.alpha()`, self.T0)


PropertyRegistration(
    'Thermal:ThermalExpansion:Anisotropic:Tetragonal', TetragonalThermalExpansion,
    "SWIG.engine.property.thermalexpansion.thermalexpansion",207,
    [symmmatrix.TetragonalRank2TensorParameter(
    'alpha',
    symmmatrix.TetragonalRank2Tensor(xx=1.0, zz=0.5), tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature.")],
    fields=[problem.Temperature],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="ThermalExpansion",
    tip='Tetragonal thermal expansion.')


class TrigonalThermalExpansion(AnisotropicThermalExpansion):
    def __init__(self, registration, name, alpha, T0):
        self.T0 = T0
        AnisotropicThermalExpansion.__init__(self, registration, self, name,
                                             alpha, T0)
    def __repr__(self):
        return "Trigonal(name='%s', alpha=%s, T0 =%g)" % \
               (self.name(),`self.alpha()`, self.T0)


PropertyRegistration(
    'Thermal:ThermalExpansion:Anisotropic:Trigonal', TrigonalThermalExpansion,
    "SWIG.engine.property.thermalexpansion.thermalexpansion",206,
    [symmmatrix.TrigonalRank2TensorParameter(
    'alpha',
    symmmatrix.TrigonalRank2Tensor(xx=1.0, zz=0.5), tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature.")],
    fields=[problem.Temperature],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="ThermalExpansion",
    tip='Trigonal thermal expansion.')


class HexagonalThermalExpansion(AnisotropicThermalExpansion):
    def __init__(self, registration, name, alpha, T0):
        self.T0 = T0
        AnisotropicThermalExpansion.__init__(self, registration, self, name,
                                 alpha, T0)
    def __repr__(self):
        return "Hexagonal(name='%s', alpha=%s, T0 =%g)" % \
               (self.name(),`self.alpha()`, self.T0)


PropertyRegistration(
    'Thermal:ThermalExpansion:Anisotropic:Hexagonal', HexagonalThermalExpansion,
    "SWIG.engine.property.thermalexpansion.thermalexpansion",205,
    [symmmatrix.HexagonalRank2TensorParameter(
    'alpha',
    symmmatrix.HexagonalRank2Tensor(xx=1.0, zz=0.5), tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature.")],
    fields=[problem.Temperature],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="ThermalExpansion",
    tip='Hexagonal thermal expansion.')


class CubicThermalExpansion(AnisotropicThermalExpansion):
    def __init__(self, registration, name, alpha, T0):
        self.T0 = T0
        AnisotropicThermalExpansion.__init__(self, registration, self, name,
                                 alpha, T0)
    def __repr__(self):
        return "Cubic(name='%s', alpha=%s, T0 =%g)" % \
               (self.name(),`self.alpha()`, self.T0)


PropertyRegistration(
    'Thermal:ThermalExpansion:Anisotropic:Cubic', CubicThermalExpansion,
    "SWIG.engine.property.thermalexpansion.thermalexpansion",204,
    [symmmatrix.CubicRank2TensorParameter(
    'alpha',
    symmmatrix.CubicRank2Tensor(xx=1.0), tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature.")],
    fields=[problem.Temperature],
    fluxes=[problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="ThermalExpansion",
    tip='Cubic thermal expansion.')
