/*
 * FILE : SRC/engine/stiffnessmatrixcmodule.C
 * 
 * This file was automatically generated by :
 * Simplified Wrapper and Interface Generator (SWIG)
 * Version 1.1 (Build 883)
 * 
 * Portions Copyright (c) 1995-1998
 * The University of Utah and The Regents of the University of California.
 * Permission is granted to distribute this file in any manner provided
 * this notice remains intact.
 * 
 * Do not make changes to this file--changes will be lost!
 *
 */


#define SWIGCODE
/* Implementation : PYTHON */

#define SWIGPYTHON
// -*- C++ -*-
// $RCSfile: pyexp.swg,v $
// $Revision: 1.1 $
// $Author: reida $
// $Date: 2004/12/20 18:55:29 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */


/* This is boilerplate code that SWIG puts around its generated C++
 * code.  The search path includes the SRC directory, so putting this
 * file here means this version is preferred to the default version
 * present as part of the SWIG 1.1 build 883 install.  This file has been
 * modified to include Python.h before anything else.
 */


#include <Python.h>

#include <string.h>
#include <stdlib.h>
/* Definitions for Windows/Unix exporting */
#if defined(__WIN32__)
#   if defined(_MSC_VER)
#	define SWIGEXPORT(a) __declspec(dllexport) a
#   else
#	if defined(__BORLANDC__)
#	    define SWIGEXPORT(a) a _export 
#	else
#	    define SWIGEXPORT(a) a 
#	endif
#   endif
#else
#   define SWIGEXPORT(a) a 
#endif

#ifdef __cplusplus
extern "C" {
#endif
#include "Python.h"
extern void SWIG_MakePtr(char *, void *, char *);
extern void SWIG_RegisterMapping(char *, char *, void *(*)(void *));
extern char *SWIG_GetPtr(char *, void **, char *);
extern char *SWIG_GetPtrObj(PyObject *, void **, char *);
extern void SWIG_addvarlink(PyObject *, char *, PyObject *(*)(void), int (*)(PyObject *));
extern PyObject *SWIG_newvarlink(void);
#ifdef __cplusplus
}
#endif
#define SWIG_init    initstiffnessmatrixc

#define SWIG_name    "stiffnessmatrixc"

#include <Python.h>	
#include "common/ooferror.h"
#include "common/cdebug.h"
#include "common/IO/threadstate.h"

#include <vector>
  typedef std::vector<double> DoubleVec;
  typedef std::vector<int> IntVec;
  typedef std::vector<unsigned short> ShortVec;

#include "common/geometry.h"
#include <vector>
  typedef std::vector<Coord*> CoordVec;
  typedef std::vector<Coord> PointVec;
  typedef std::vector<CSegment*> CSegmentVec;
  typedef std::vector<ICoord> ICoordVec;
  typedef std::vector<std::string> StringVec;
  typedef std::vector<char*> CharPtrVec;

#include <string>
using std::string;

#include "engine/gausspoint.h"
typedef std::vector<GaussPoint*> GaussPointVec;

#include "engine/mastercoord.h"
#include <vector>
  typedef std::vector<MasterCoord*> MasterCoordVec;

  typedef std::vector<PyObject*> PyObjectVec;

#include "engine/matvec.h"
  typedef std::vector<VECTOR_D*> VecVec;

  typedef std::vector<const double*> DoubleStarVec;

#include "engine/symmmatrix.h"
  typedef std::vector<SymmMatrix3*> SymmMatrix3StarVec;

#include <vector>
#include <engine/node.h>
  typedef std::vector<Node*> NodeVec;

#include <vector>
#include <engine/field.h>
  typedef std::vector<CompoundField*> CompoundFieldVec;

#include <vector>
#include <engine/equation.h>
  typedef std::vector<Equation*> EquationVec;

#include <vector>
#include <engine/flux.h>
  typedef std::vector<Flux*> FluxVec;

#include "engine/edge.h"
  typedef std::vector<Edge*> EdgeVec;

  typedef std::vector<OutputValue> OutputValueVec;

#include "stiffnessmatrix.h"
#include "sparselink.h"
  /* This is a duplicate typedef, because we inherit from SparseLinkMat
     here.  The other one is in sparselink.swg. */
  typedef SparseLinkMatrix<double> SparseLinkMat;
#ifdef __cplusplus
extern "C" {
#endif
static void *SwigStiffnessMatrixToSparseLinkMat(void *ptr) {
    StiffnessMatrix *src;
    SparseLinkMat *dest;
    src = (StiffnessMatrix *) ptr;
    dest = (SparseLinkMat *) src;
    return (void *) dest;
}

#define StiffnessMatrix_nrows(_swigobj)  (_swigobj->nrows())
static PyObject *_wrap_StiffnessMatrix_nrows(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    StiffnessMatrix * _arg0;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"O:StiffnessMatrix_nrows",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_StiffnessMatrix_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of StiffnessMatrix_nrows. Expected _StiffnessMatrix_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        _result = (int )StiffnessMatrix_nrows(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define StiffnessMatrix_ncols(_swigobj)  (_swigobj->ncols())
static PyObject *_wrap_StiffnessMatrix_ncols(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    StiffnessMatrix * _arg0;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"O:StiffnessMatrix_ncols",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_StiffnessMatrix_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of StiffnessMatrix_ncols. Expected _StiffnessMatrix_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        _result = (int )StiffnessMatrix_ncols(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

static double  StiffnessMatrix_get(StiffnessMatrix *self,int  i,int  j) {
      return (*self)(i, j);
    }
static PyObject *_wrap_StiffnessMatrix_get(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    double  _result;
    StiffnessMatrix * _arg0;
    int  _arg1;
    int  _arg2;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"Oii:StiffnessMatrix_get",&_argo0,&_arg1,&_arg2)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_StiffnessMatrix_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of StiffnessMatrix_get. Expected _StiffnessMatrix_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        _result = (double )StiffnessMatrix_get(_arg0,_arg1,_arg2);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    _resultobj = Py_BuildValue("d",_result);
    return _resultobj;
}

static PyMethodDef stiffnessmatrixcMethods[] = {
	 { "StiffnessMatrix_get", _wrap_StiffnessMatrix_get, METH_VARARGS },
	 { "StiffnessMatrix_ncols", _wrap_StiffnessMatrix_ncols, METH_VARARGS },
	 { "StiffnessMatrix_nrows", _wrap_StiffnessMatrix_nrows, METH_VARARGS },
	 { NULL, NULL }
};
#ifdef __cplusplus
}
#endif
/*
 * This table is used by the pointer type-checker
 */
static struct { char *n1; char *n2; void *(*pcnv)(void *); } _swig_mapping[] = {
    { "_signed_long","_long",0},
    { "_class_SparseLinkMat","_class_StiffnessMatrix",SwigStiffnessMatrixToSparseLinkMat},
    { "_class_SparseLinkMat","_StiffnessMatrix",SwigStiffnessMatrixToSparseLinkMat},
    { "_class_SparseLinkMat","_SparseLinkMat",0},
    { "_long","_unsigned_long",0},
    { "_long","_signed_long",0},
    { "_StiffnessMatrix","_class_StiffnessMatrix",0},
    { "_class_StiffnessMatrix","_StiffnessMatrix",0},
    { "_CSparseLinkMatIterator","_class_CSparseLinkMatIterator",0},
    { "_unsigned_long","_long",0},
    { "_signed_int","_int",0},
    { "_unsigned_short","_short",0},
    { "_signed_short","_short",0},
    { "_unsigned_int","_int",0},
    { "_short","_unsigned_short",0},
    { "_short","_signed_short",0},
    { "_class_CSparseLinkMatIterator","_CSparseLinkMatIterator",0},
    { "_SparseLinkMat","_class_StiffnessMatrix",SwigStiffnessMatrixToSparseLinkMat},
    { "_SparseLinkMat","_StiffnessMatrix",SwigStiffnessMatrixToSparseLinkMat},
    { "_SparseLinkMat","_class_SparseLinkMat",0},
    { "_int","_unsigned_int",0},
    { "_int","_signed_int",0},
{0,0,0}};

static PyObject *SWIG_globals;
#ifdef __cplusplus
extern "C" 
#endif
SWIGEXPORT(void) initstiffnessmatrixc() {
	 PyObject *m, *d;
	 SWIG_globals = SWIG_newvarlink();
	 m = Py_InitModule("stiffnessmatrixc", stiffnessmatrixcMethods);
	 d = PyModule_GetDict(m);
{
   int i;
   for (i = 0; _swig_mapping[i].n1; i++)
        SWIG_RegisterMapping(_swig_mapping[i].n1,_swig_mapping[i].n2,_swig_mapping[i].pcnv);
}
}
